# -*- coding: utf-8 -*-
"""
Created on Thu Feb  4 10:18:42 2021
@author: higha
"""
# C F Higham University of Glasgow 14/03/2023

import numpy as np
import timeit
import matplotlib.pyplot as plt
import pickle

# Import the functions and packages that are used
from dwave.system import EmbeddingComposite, DWaveSampler
from dwave.system import FixedEmbeddingComposite
from minorminer import find_embedding
dwave_sampler = DWaveSampler(solver={'topology__type': 'pegasus'},token='myToken')





import csv
numcases=5000
numdims=225
data=np.zeros([numcases,numdims])#end row contains biases
ct=0
with open('/workspace/myDrive/bXTest1104.csv', newline='') as f:
    reader = csv.reader(f)
    for line in reader:
        #print(line)
        data[ct,:]=line
        ct=ct+1



dim1=513
w1=np.zeros([dim1,dim1])#end row contains biases
ct=0
with open('/workspace/myDrive/myQ0330_5_8_mysig8_MNIST.csv', newline='') as f:
    reader = csv.reader(f)
    for line in reader:
        w1[ct,:]=line
        ct=ct+1

# Set Temperature parameter
S=8
Q={}
for i in range(dim1):
    for j in range(dim1):
        if w1[i,j]==0:
            pass
        else:    
            Q[(i,j)]= -S*w1[i,j]






energy10=[]
myclass=[]
myclassb=[]


    

j2=np.concatenate((np.arange(0,10,1),np.arange(500,510,1),np.arange(1000,1010,1),np.arange(1500,1510,1),np.arange(2000,2010,1),np.arange(2500,2510,1),np.arange(3000,3010,1),np.arange(3500,3510,1),np.arange(4000,4010,1),np.arange(4500,4510,1)))

numtestcases=100

for i3 in range(numtestcases):
    
    
    ##### add clamp   #####
    
    clamp_strength = 50
    n_to_clamp = numdims
    position=range(numdims)
    i4=j2[i3]

    value=data[i4,:]
        
   
    for to_clamp in range(n_to_clamp):
        this_idx = position[to_clamp]
        this_value = value[to_clamp]
        if this_value == 0:  # x=0
        # Update bias to force sample[this_idx] to be 0
            Q[(this_idx, this_idx)] = clamp_strength
        else:  # x == 1:
        # Update bias to force sample[this_idx] to be 1
            Q[(this_idx, this_idx)] = -1 * clamp_strength
        # Update w given sample[this_idx] = 1
            for (x, y) in Q:
                if (x == this_idx or y == this_idx) and x != y:
                    pass  # no need to change 
        
        

    sampleset = sampler.sample_qubo(Q, num_reads = 500)
    ph3=sampleset.record.sample#[0]
    
    energy1=sampleset.record.energy
    b=np.argsort(energy1)

    ph4=ph3[b[0:100],:]
    ph4b=ph3[b[0:500],:]
 
    energy10.append(energy1[b[0:500]])
    myclass.append(np.sum(ph4,0))
    myclassb.append(np.sum(ph4b,0)) 


with open('/workspace/myDrive/results/MNIST_S8W_mysig8_0330_5_8_100_500_100all', 'w', newline='') as f:
    # create the csv writer
    writer = csv.writer(f)
    for i in range(numtestcases):
        # write a row to the csv file
        writer.writerow(myclass[i])

with open('/workspace/myDrive/results/MNIST_S8W_mysig8_0330_5_8_500_500_100all', 'w', newline='') as f:
    # create the csv writer
    writer = csv.writer(f)
    for i in range(numtestcases):
        # write a row to the csv file
        writer.writerow(myclassb[i])


with open('/workspace/myDrive/results/energy_S8W_mysig8_0330_5_8_500_500_100all', 'w', newline='') as f:
    # create the csv writer
    writer = csv.writer(f)
    for i in range(numtestcases):
        # write a row to the csv file
        writer.writerow(energy10[i])   
