# -*- coding: utf-8 -*-
"""
Created on Thu Feb  4 10:18:42 2021

@author: higha
"""
# C F Higham University of Glasgow 14/03/2023

import numpy as np
import timeit
import matplotlib.pyplot as plt
import pickle

# Import the functions and packages that are used
from dwave.system import EmbeddingComposite, DWaveSampler
from dwave.system import FixedEmbeddingComposite
from minorminer import find_embedding
dwave_sampler = DWaveSampler(solver={'topology__type': 'pegasus'},token='myToken')

import csv

numcases=100
numdims=146
data=np.zeros([numcases,numdims])#end row contains biases
ct=0
with open('/workspace/myDrive/hbias_146_1230.csv', newline='') as f:
    reader = csv.reader(f)
    for line in reader:
        #print(line)
        data[ct,:]=line
        ct=ct+1


dim1=146
dimc=10
w1=np.zeros([dim1,dimc])#end row contains biases
ct=0
with open('/workspace/myDrive/wclass.csv', newline='') as f:
    reader = csv.reader(f)
    for line in reader:
        w1[ct,:]=line
        ct=ct+1

Q={}

for i in range(dim1):
    Q[(i, i)] = -1 

for i in range(dim1):
    for j in range(dimc):
        Q[(i,dim1+j)]= -1*w1[i,j]


for i in range(dimc):
    Q[(i+dim1,i+dim1)]=0

# lambda=8
for i in range(dimc):    
    for j in range(dimc-1-i):
        Q[(i+dim1,i+dim1+j+1)]=8



with open('/workspace/myDrive/emb1207_MNIST.pkl','rb') as f:  # Python 3: open(..., 'rb')
     embedding = pickle.load(f) 

sampler = FixedEmbeddingComposite(dwave_sampler, embedding)






energy10=[]
myclass=[]

    
numtestcases=100

for i3 in range(numtestcases):

    ##### add clamp   #####
    
    clamp_strength = 50
    n_to_clamp = numdims
    position=range(numdims)
    value=data[i3,:]
        
 
    
    for to_clamp in range(n_to_clamp):
        this_idx = position[to_clamp]
        this_value = value[to_clamp]
        if this_value == 0:  # x=0
        # Update bias to force sample[this_idx] to be 0
            Q[(this_idx, this_idx)] = clamp_strength
        else:  # x == 1:
        # Update bias to force sample[this_idx] to be 1
            Q[(this_idx, this_idx)] = -1 * clamp_strength
        # Update w given sample[this_idx] = 1
            for (x, y) in Q:
                if (x == this_idx or y == this_idx) and x != y:
                    pass  # no need to change 
        
        

    sampleset = sampler.sample_qubo(Q, num_reads = 10)
    ph3=sampleset.record.sample#[0]
    
    energy1=sampleset.record.energy
    b=np.argsort(energy1)

    
    ph4=ph3[b[0:10],:]
    

    energy10.append(energy1[b[0:10]])
    myclass.append(np.sum(ph4,0))
    


with open('/workspace/myDrive/results/MNIST_1230_146_M8_10_10_x100', 'w', newline='') as f:
    # create the csv writer
    writer = csv.writer(f)
    for i in range(numtestcases):
        # write a row to the csv file
        writer.writerow(myclass[i])

with open('/workspace/myDrive/results/energy_1230_146_M8_10_x100', 'w', newline='') as f:
    # create the csv writer
    writer = csv.writer(f)
    for i in range(numtestcases):
        # write a row to the csv file
        writer.writerow(energy10[i])   